<div id="this">
  <div class="top-panel">
    <h2>{{ title }}</h2>
    <button mat-icon-button (click)="addClickHandler()" aria-label="Add item">
      <mat-icon>add</mat-icon>
    </button>
    <button
      mat-icon-button
      (click)="updateData()"
      aria-label="Update data table"
    >
      <mat-icon>update</mat-icon>
    </button>
  </div>
  <table mat-table [dataSource]="data" class="mat-elevation-z8">
    <ng-container *ngFor="let col of autoDataColumns" matColumnDef="{{ col }}">
      <th mat-header-cell *matHeaderCellDef>
        {{ col[0].toUpperCase() + col.substring(1) }}
      </th>
      <td mat-cell *matCellDef="let element">{{ element[col] }}</td>
    </ng-container>

    <ng-container matColumnDef="controls">
      <th mat-header-cell *matHeaderCellDef></th>
      <td mat-cell *matCellDef="let element" class="header-align-right">
        <button
          mat-icon-button
          (click)="editClickHandler(element)"
          aria-label="Edit item"
        >
          <mat-icon>edit</mat-icon>
        </button>
        <button
          mat-icon-button
          color="warn"
          (click)="deleteClickHandler(element)"
          aria-label="Remove item"
        >
          <mat-icon>delete</mat-icon>
        </button>
      </td>
    </ng-container>

    <tr mat-header-row *matHeaderRowDef="displayedColumns"></tr>
    <tr mat-row *matRowDef="let row; columns: displayedColumns"></tr>
  </table>
</div>
